//Функция, вычисляющая разность между экспериментальными 
//и теоретическими значениями. 
//Перед использованием необходимо определить
//z=[x;y] - матрицу исходных данных - и
//с - вектор начальных значений коэффициентов,
//размерность вектора должна совпадать 
//с количеством искомых коэффициентов.
function [zr]=G(c,z)
zr=z(2)-c(1)-c(2)*z(1)-c(3)*z(1)^2-c(4)*z(1)^3
endfunction
//Исходные данные
x=[1.32 1.40 1.50 1.62 1.70 1.80 1.90...
   2.00,2.11,2.20,2.32,2.40,2.51];
y=[3.30 3.50 3.85 4.25 4.50 4.85 5.40...
   6.00 6.60 7.30 9.20 10.20 13.50];
n=size(x)(2);
//Формирование матрицы исходных данных
z=[x;y];
//Вектор начальных приближений 
c=[0;0;0;0];
//Решение задачи
[a,err]=datafit(G,z,c);
//Построение графика экспериментальных данных
plot2d(x,y,-4);
//Построение графика подобранной функции
hx=(x(n)-x(1))/100;

t=x(1):hx:x(n);
Ptc=a(1)+a(2)*t+a(3)*t^2+a(4)*t^3;
plot2d(t,Ptc);
mprintf("Суммарная квадратичная ошибка=%6.2f\n",err)
mprintf("Подобранные коэффициенты полинома ")
for i=1:4
    mprintf("%6.4f ",a(i))
end
mprintf("\n")