//Правая часть дифференциального уравнения.
function y=f(x,t)
y=sin(x*t)
//y=0;
endfunction
//Начальное условие
function y=fi(x)
y=exp(0.15*x)
endfunction
//Условие на левой границе
function y=myu(t)
y=1
endfunction
//Условие на правой границе
function y=nyu(x)
y=2.117
endfunction
function [u,x,t,r,k]=neyavn(N,K,L,T,a,eps)
//Функция решения параболического уравнения методом сеток с
//помощью неявной разностной схемы.
//Вычисляем шаг по х
h=L/N;
//Вычисляем шаг по t
delta=T/K;
//Формируем массив x и первый столбец матрицы решений U 
//из начального условия
for i=1:N+1
x(i)=(i-1)*h;
u(i,1)=fi(x(i));
end
//Формируем массив t, первую и последнюю строку матрицы
//решений U из граничных условий
for j=1:K+1
t(j)=(j-1)*delta;
u(1,j)=myu(t(j));
u(N+1,j)=nyu(t(j));
end
//Определяем матрицу ошибок R и заполняем ее нулями 
R(N+1,K+1)=0;
//Вычисляем коэффициент gamma
gam=a^2*delta/h^2;
r=1;
k=0;
//Цикл while для организации итерационного процесса при
//решении системы уравнений (12.14) методом Зейделя с
//точностью eps 
while r>eps
//Вычисление матрицы ошибок R во внутренних точках
//и пересчет значений u во внутренних точках при решениии СЛАУ
//(12.14) методом Зейделя
for i=2:N
for j=2:K+1
R(i,j)=abs(u(i,j)-gam/(1+2*gam)*(u(i-1,j)+u(i+1,j))-u(i,j-1)/(1+2*gam)-delta*f(x(i),t(j))/(1+2*gam));
u(i,j)=gam/(1+2*gam)*(u(i-1,j)+u(i+1,j))+u(i,j-1)/(1+2*gam)+delta*f(x(i),t(j))/(1+2*gam);
end
end
//Поиск максимума в матрице ошибок
r=R(1,1);
for i=1:N+1
for j=1:K+1
if R(i,j)>r 
r=R(i,j);
end
end
end
//Увеличение количества итерации.
k=k+1;
end
disp(k)
endfunction
[U,X,T]=neyavn(50,200,5,3,0.4,0.1);
surf(X,T,U');
title('PARABOLIC EQUATION');
xlabel('X');
ylabel('T');
